open Hash;;
open Mathdata;;

let checkdocs2_main oc h hr =
  let locgvtph : (hashval * Logic.stp,unit) Hashtbl.t = Hashtbl.create 100 in
  let locgvknh : (hashval,unit) Hashtbl.t = Hashtbl.create 100 in
  let locgvtp _ h1 a =
    Hashtbl.mem locgvtph (h1,a)
  in
  let locgvkn =
    (fun _ k -> Hashtbl.mem locgvknh k)
  in
  let f = open_in_bin h in
  let thyspec : Logic.theoryspec = Marshal.from_channel f in
  let ((pl,kl) as thy) = theoryspec_theory thyspec in
  List.iter (fun k -> Hashtbl.add locgvknh k ()) kl;
  let th = hashtheory thy in
  let cnt = ref 0 in
  let tm = Unix.gettimeofday() in
  let checkdocs2 h f =
    begin
      try
        while true do
          let d : Logic.doc = Marshal.from_channel f in
          incr cnt;
          match Checking.check_doc (ref 0) locgvtp locgvkn th thy d with
          | None -> raise (Failure (Printf.sprintf "Doc %d failed\n" !cnt))
          | Some(gsl,kl) ->
             (** now, export types of hashes of (potentially) new defns and export hashes of (potentially) new knowns **)
             List.iter (fun ((h,a),_) -> Hashtbl.replace locgvtph (h,a) ()) gsl;
             List.iter (fun (k,_) -> Hashtbl.replace locgvknh k ()) kl
        done
      with End_of_file ->
        close_in f;
        Printf.fprintf oc "Done with %s\nDocs: %d\nTime: %f\n%!" h !cnt (Unix.gettimeofday() -. tm);
    end
  in
  checkdocs2 h f;
  List.iter (fun h -> let f = open_in_bin h in checkdocs2 h f) hr;;

begin
  match Array.to_list Sys.argv with
  | (_::h::hr) -> checkdocs2_main stdout h hr
  | _ -> Printf.printf "Expected: checkdocs <file1> [<file2> ... <filen>]\nNo files given.\n"
end;;
